class InsxArgumentError < ArgumentError
  def initialize(usage, classname, trace)
    method = trace[0][/`([^']+)'/,1] == "initialize" ? "new" : trace[0][/`([^']+)'/,1]
    message = "\n#{classname}.#{method}: Argument validation failed\n"
    message += "Usage definition(s):\n"

    Array(usage).each {|line| message += "\t#{classname}.#{method}(#{line})\n"}

    message += "Trace:"
    super(message)
    self.set_backtrace(trace)
  end
end